<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\PenggunaanbarangService;
use App\Http\Validators\PenggunaanbarangValidator;
use App\Http\Services\LokasiitemService;
use App\Http\Services\ItempenggunaanbarangService;
use App\Http\Services\AccountService;
use App\Http\Services\VoyagesService;
use App\Http\Services\UsersService;
use App\Http\Services\StokkapalService;
use App\Http\Services\ActivitylogService;
use PDF;


class PenggunaanbarangController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $lokasiitem;
    private $account;
    private $itempenggunaanbarang;
    private $voyage;
    private $users;
    private $stokkapal;
    private $activityLog;
    /**
     * Penggunaanbarang constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new PenggunaanbarangService();
        $this->validator = new PenggunaanbarangValidator();
        $this->account = new AccountService();
        $this->lokasiitem = new LokasiitemService();
        $this->users = new UsersService();
        $this->voyage = new VoyagesService();
        $this->itempenggunaanbarang = new ItempenggunaanbarangService();
        $this->stokkapal = new StokkapalService();
        $this->activityLog= new ActivitylogService();
    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $input = $request->all();
        // var_dump($input); dd();
        $this->validator->beforeInsert($input);
        if ($this->validator->hasError()) 
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $auth = json_decode($request->session()->get('auth'));
 
            $input["miNumber"] = $this->baseService->getLastestID("MI" . date("y") . $auth->orgId);
            $ID = $this->baseService->store($input);
            $this->itempenggunaanbarang->store($input);

            $stockHistory = [
                "transaksi"     => "penggunaanbarang",
                "noTransaksi"   => $input["miNumber"],
                "username"      => $auth->username,
                "periode"       => $input["tglPenggunaan"]
            ];
            $items = $this->itempenggunaanbarang->prepareReduceStock($input);
            $this->stokkapal->reduceStock($items, $stockHistory);

            $input["date"] = date("Y-m-d H:i:s");
            $input["username"] = $auth->username;
            $input["activity"] = "CREATE";
            $input["urlTransaksi"] = "penggunaanbarang";
            $input["namaTransaksi"] = "Penggunaan Barang";
            $input["refId"] = $input["miNumber"];
            $input["deskripsi"] = $auth->name . " just <b>created</b> new Penggunaan Barang <a href=\"" . url("administrator/penggunaanbarang/" . $ID) . "\">" . $input["miNumber"] . "</a>";
            $this->activityLog->store($input);

            $input["subinventory_code"] = $this->lokasiitem->showByLokasiID($input["locationId"]);

            $this->baseService->saveStaging($input);

            DB::commit();
            $this->sync();
            return redirect()->to("administrator/penggunaanbarang")->with("successMessages", "Data sudah berhasil disimpan dengan No #" . $input["refId"]);
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = [
            "id" => "ID"
            , "namaLokasi" => "Asal"
            , "destinationAccount" => "Account"
            , "date" => "Tanggal Penggunaan"
        ];
        $this->data["criteria"] = [
            "id" => "ID"
            , "namaLokasi" => "Asal"
            , "destinationAccount" => "Account"
            , "date" => "Tanggal Penggunaan"
        ];
        $this->data["ordering"] = [
            "miNumber:asc" => "No Transaksi &uarr;"
            , "miNumber:desc" => "No Transaksi &darr;"
            , "tglPenggunaan:asc" => "Tgl Penggunaan &uarr;"
            , "tglPenggunaan:desc" => "Tgl Penggunaan &darr;"
            , "voyageKode:asc" => "Voyage &uarr;"
            , "voyageKode:desc" => "Voyage &darr;"
        ];
        $this->data["accounts"] = $this->account->index();
        $this->data["voyages"] = $this->voyage->getVoyages($request);
        $this->data["penggunaanbarangs"] = $this->baseService->paging($request);
        return view("modules.penggunaanbarang.penggunaanbarang_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $this->data["penggunaanbarang"] = $this->baseService->show($id);
        $this->data["criteria"] = [  "id" => "ID" ,   "namaItem" => "Nama Item"   , "deskripsi" => "Deskripsi" ];
        $this->data["listItems"] = $this->itempenggunaanbarang->showBasedOnPenggunaanBarang($this->data["penggunaanbarang"]);
        return view("modules.penggunaanbarang.penggunaanbarang_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/penggunaanbarang")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create(Request $request) {
        $this->data["lokasiitems"] = $this->lokasiitem->index($request);
        $this->data["accounts"] = $this->account->index();

        $this->data["criteria"] = [            
            "deskripsi"     => "Deskripsi" ,
            "part_number"    => "Part Number",
            "namaItem"      => "Kode Item"
        ];
        // $this->data["voyages"] = $this->voyage->index();
        return view("modules.penggunaanbarang.penggunaanbarang_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Request $request, $id)
    {
        try{
            $this->data["penggunaanbarang"] = $this->baseService->show($id);    
            if($this->data["penggunaanbarang"]) {
                $this->data["listItems"] = $this->itempenggunaanbarang->showBasedOnPenggunaanBarang($request, $this->data["penggunaanbarang"]);   
                return view("modules.penggunaanbarang.penggunaanbarang_show", $this->data);
            } else {
                return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
            }
        } catch (\Exception $e) {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }

    public function search(Request $request) {
        $data = $this->stokkapal->getStokList($request);
        echo json_encode($data); 
    }

}